{'Accepts a header and pulls out properties
{
Properties are no longer automatically strings, they need to be typed
<...       PROPERTIES="Width:integer;Height:integer;"   ...>
you have to have them all separated out, no "width,height:integer".. its just a pain to parse!
Maybe later when I can build a lexical based Preprocessor then it would be
easier...


for class based properties, you'll just have to make sure you create them
.. 

avoid them.. for something like Content you should make a method WriteContent which
would create the property if necessary and then populate it...

This is definitely something for discussion, since I don't want to add ANOTHER tag
for doing Creation... 

perhaps if you define a method "OnCreate" I can call it, something
like Delphi's TForm event of the same name.. also "OnDestroy"... by assigning a mthod
with either name you will automatically hook into that cycle...
 yucky for my coding, really nice for yours.
 }

unit PreprocessProperties;

interface

uses classes,sysutils,lowx,strutils;

function produceWCPrivateDeclaration(Data:String)   :String;
function produceWCPublishedDeclaration(Data:String)  :String;
function producePropertiesPublisheddeclaration (Data:String):String;
function producePropertiesPrivatedeclaration (Data:String):String;

implementation

function processTypedListPrivate (typedlist:String):String;
var PropList:TStringlist;outhold,pName,pType,hold :String; i:integer;
begin
 Proplist:=tstringlist.create;
 hold:=typedlist;
 while pos(';',hold)<>0 do hold:=replacestring(hold,';',#13+#10);
 while pos(':',hold)<>0 do hold:=replacestring(hold,':','=');
 Proplist.text:=hold;
{ok.. now we have a propertyList with 'NAME=TYPE'.. build that list!}

 outhold:='';
 for i:= 0 to Proplist.count-1 do
   begin
    pName:=Proplist.names[i];
    pType:=Proplist.values[pName];
    outhold:=outhold+ '  f'+ PName+' : '+PType+';'+#13+#10;
   end;

{clean up}
 proplist.clear;
 proplist.free;
{accepts a <COMPONENT definition tag and gives you the private declaration}
result:=outhold;
end;

function ProcessTypedListPublished (typedlist:String):String;
var PropList:TStringlist;hold,outhold,pName,pType :String; i:integer;
begin
 Proplist:=tstringlist.create;
 hold:=typedlist;
 while pos(';',hold)<>0 do hold:=replacestring(hold,';',#13+#10);
 while pos(':',hold)<>0 do hold:=replacestring(hold,':','=');
 Proplist.text:=hold;
{ok.. now we have a propertyList with 'NAME=TYPE'.. build that list!}

 outhold:='';
 for i:= 0 to Proplist.count-1 do
   begin
    pName:=Proplist.names[i];
    pType:=Proplist.values[pName];
    outhold:=outhold+ ' property '+PName+' : '+PType+' read f'+pname+' write f'+pname+';'+#13+#10;
   end;

{clean up}
 proplist.clear;
 proplist.free;
{accepts a <COMPONENT definition tag and gives you the private declaration}
result:=outhold;
end;

function processWCParamList (Data:String):String;
{returns a propertylist string}
var wclist:tstringlist; wcnametype_list,wcName,wcClass,thiswc:String; i:integer;
begin
 wclist:=tstringlist.create;
 wclist:= GetTermTagList(Data,'WEBCOMPONENT');
 for i:= 0 to wclist.count-1 do
  begin
   thiswc:=wclist[i];
   wcName:=GetTermTagProperty (thiswc,'WEBCOMPONENT','NAME');
   wcClass:=GetTermTagProperty (thiswc,'WEBCOMPONENT','CLASS');
   wcnametype_list:=wcnametype_list + wcName + ':'+ wcClass;
   if i<wclist.count-1 then wcnametype_list:=wcnametype_list+';';
  end;
 result:=wcnametype_list;
 wclist.clear;
 wclist.free;
end;

function produceWCPrivateDeclaration(Data:String)   :String;
var outhold,listhold:String;
begin
 listhold:=processWCParamList(Data);
 outhold:= ProcessTypedListPrivate(listhold);
 result:=outhold;
end;

function produceWCPublishedDeclaration(Data:String)  :String;
var outhold,listhold:String;
begin
 listhold:=processWCParamList(Data);
 outhold:= ProcessTypedListPublished(listhold);
 result:=outhold;
end;

function producePropertiesPublisheddeclaration (Data:String):String;
var outhold:String;
begin
 outhold:= ProcessTypedListPublished (GetTagProperty(Data,'COMPONENT','PROPERTIES'));
 result:=outhold;
end;

function producePropertiesPrivatedeclaration (Data:String):String;
var hold,outhold :String; 
begin
 outhold:= ProcessTypedListPrivate (GetTagProperty(Data,'COMPONENT','PROPERTIES'));
 result:=outhold;
end;

end.



